//+------------------------------------------------------------------+
//|                                                         test.mq5 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
input bool limitarBarras	= false;
input int  limite			= 100;

#include <Header.mqh>
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot arrow
#property indicator_label1  "Bar"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- indicator buffers
double BBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,BBuffer,INDICATOR_DATA);
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW
   PlotIndexSetInteger(0,PLOT_ARROW,159);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
	inicializarBuffersOHLCTV(prev_calculated, rates_total);
	int margenMin = 50, prevCalc = prev_calculated;
	int barrasPorAnalizar = rates_total - prevCalc;
	if(barrasPorAnalizar==0)barrasPorAnalizar=50;
	
	/*if(limitarBarras) //<-- Don't know how to limit the bars of the loop
	{
		if(prevCalc>limite) prevCalc = limite;
		barrasPorAnalizar = limite - prevCalc +5;
	}*/
	//Print("barrasPorAnalizar = ",barrasPorAnalizar);
	
	//for(int i=1;i<=barrasPorAnalizar;i++)
	for(int i=1;i<= (rates_total-10);i++) //<-- How can I limit this just to a fix number or the new bars are coming
	{
		/*if(close[i]>close[i-1]) //<--Just to see if the problem is in the loop itself
		{
			BBuffer[i]=open[i];
		}*/
		if(B_Bars(false, 5, i))
		{
			BBuffer[i+2]=close[i+2];
			//Print("Seal en i=",i,", open[i] = ", open[i]," Open[i] = ",Open[i]); //<-- If you compare the open[i] with the Open[i], the open[i] doesn't have any sense
																					//<-- I don't know how to work with opens, closes, etc
		}
		else BBuffer[i]=0;
	}
	
	return(rates_total);
}
//+------------------------------------------------------------------+

void inicializarBuffersOHLCTV(int prevCalculated, int ratesTotal)
{
	int count = ratesTotal +1;
	ArrayResize(Open,(count+10));ArrayResize(Close,(count+10));ArrayResize(High,(count+10));ArrayResize(Low,(count+10));ArrayResize(Time,(count+10));ArrayResize(RealVolume,(count+10));ArrayResize(TickVolume,(count+10));
	//Print("inicializacionBuffersOHLCTV: count = ", count," ,prevCalculated = ", prevCalculated,", Size: ", ArraySize(Open));
	iOpen(Symbol(),Period(),count,0);
	iClose(Symbol(),Period(),count,0);
	iHigh(Symbol(),Period(),count,0);
	iLow(Symbol(),Period(),count,0);
	iTime(Symbol(),Period(),count,0);
	iRealVolume(Symbol(),Period(),count,0);
	iTickVolume(Symbol(),Period(),count,0);
}

double conversion(string symbol)
{
	if(symbol=="" || symbol == Symbol())
	{
		if(_Point==0.00001) return(0.0001);
		else if(_Point==0.001) return(0.01);
		else return(_Point);
	}
	else
	{
		double tPoint = SymbolInfoDouble(Symbol(),SYMBOL_POINT);
		if(tPoint==0.00001) return(0.0001);
		else if(tPoint==0.001) return(0.01);
		else return(tPoint);
	}
}

//+------------------------------------------------------------------+
string TFToStr(int tf)
//+------------------------------------------------------------------+
// Converts a MT4-numeric timeframe to its descriptor string
// Usage:   string s=TFToStr(15) returns s="M15"
{
	switch (tf)  {
		case     1 :  return("M1");
		case     2 :  return("M2");
		case     3 :  return("M3");
		case     5 :  return("M5");
		case    10 :  return("M10");
		case    15 :  return("M15");
		case    30 :  return("M30");
		case    60 :  return("H1");
		case   240 :  return("H4");
		case  1440 :  return("D1");
		case 10080 :  return("W1");
		case 43200 :  return("MN");
	}  
	return("");
} 

//Devuelve true si el cuerpo de la vela anterior es mayor que las 3 velas anteriores a esa vela
bool B_Bars(bool modeHG, int numeroCheckVelas, int shift) //valor normal numeroCheckVelas = 5, shift = velaActual(sin cerrar)
{//iOpen(	string symbol, int timeframe, int shift) 
	int timeFrame = Period(); string par = Symbol();
   	double precioOpen[], precioClose[], tamanoVela[];
	double maxOpenAct = 0, maxOpen = 0, maxCloseAct = 0, maxClose = 10000;
	bool todoOK = false, tamanoOK = false;
	ArrayResize(precioOpen,(numeroCheckVelas+1));ArrayResize(precioClose,(numeroCheckVelas+1));ArrayResize(tamanoVela,(numeroCheckVelas+1));

	for(int i = 1; i <= numeroCheckVelas; i++)
	{
		//tenemos que analizar todas las velas menos 
		// i == -1 --> analizamos la vela shift == 1, i == 0 --> shift = 2...
		//Print("Range: ", ArrayRange(Open,(shift+i)), ", Size: ", ArraySize(Open),", shift+i = " + (shift+i));
		precioOpen[i] = Open[shift+i];
		precioClose[i]  = Close[shift+i];
		tamanoVela[i] = MathAbs(precioOpen[i] - precioClose[i])/conversion(par);
		
		//if(shift == vela) Print("Fecha Shift: " + TimeToStr(iTime(par,timeFrame,(shift+i))) + ", tamanoVela["+(i)+"]: " + tamanoVela[i]);   
		
		if(i == numeroCheckVelas)
		{	
			for(int j = 1; j <= numeroCheckVelas; j++)
			{
				if(j>2) //Comprobamos tamaos
				{
					if( tamanoVela[2] <= tamanoVela[j]) {tamanoOK = false; break;}
					if( j == numeroCheckVelas && tamanoVela[2] > tamanoVela[j]) tamanoOK = true;
				}
			}
			//if(shift == vela) Print("Comprobacion Tamaos: tamanoOK = " + tamanoOK);
		}
	}
	
	if(modeHG && tamanoOK)
	{
       	int shiftB = (shift+2);
    	double O = Open[shiftB];
    	double C = Close[shiftB];
    	bool velaAlcista = false, velaBajista = false, velaDoji = false;
    	if(C>O) velaAlcista = true;
    	else if (C<O) velaBajista = true;
    	else velaDoji = true;
    	bool BHG = false;
    	
    	if(velaAlcista)
    	{
    		double Hant  = High[shiftB+1];
    		double Lpost = Low[shiftB-1];
    		
    		if(Hant < Lpost) BHG = true; 
    	}
    	
    	if(velaBajista || velaDoji)
    	{
    		double Lant  = Low[shiftB+1];
    		double Hpost = High[shiftB-1];
    		
    		if(Lant > Hpost) BHG = true; 
    	}
    	
    	if(BHG) todoOK = true;
    }
    else {if(tamanoOK) todoOK = true;}
   	//if(shift == shiftVela)Print("todoOK: " + todoOK);
  	return(todoOK);	
}

